/*****************************************************************************

                'J' - Yet Another Molecular Mechanics Program

                           (c) 1995 Jan T Pedersen


This program is not in the public domain and may not be used or distributed
by anyone without the written permission of the author. The functionality
of the whole or parts of the program is not guaranteed.

******************************************************************************
* $Header$
* $Revision$
******************************************************************************/
#include "Alloc.h"

int AllocSmallMolecule (SmallMolecules *sys, int lnat, int lnbd)
{
SmallMolecule **mol;
int ibytes=0, i,j ;
int ialloc = 0;

#ifdef DBG
fprintf (stdout,"DBG >> AllSmallMolecule()\n");
#endif

if (sys->nmol < N_SMALL_MOLS)
	{
	ialloc = sys->nmol;
	}
else
	{
	ialloc = N_SMALL_MOLS;
	}
sys->smol = 0;

if ((mol = (SmallMolecule **) calloc (ialloc, (size_t)sizeof(SmallMolecule *)))==NULL)
	{
	ErrTrace ("AllSmallMolecule",OUTOFMEM);
	return (OUTOFMEM);
	}
ibytes += (ialloc*sizeof(SmallMolecule *));
	
for (i=0; i<ialloc; i++)
	{
	if ((mol[i] = (SmallMolecule *) malloc ((size_t)sizeof(SmallMolecule)))==NULL)
		{
		ErrTrace ("AllocSmallMolecule",OUTOFMEM);
		return (OUTOFMEM);
		}
        ibytes += sizeof(SmallMolecule);

	if ((mol[i]->molname = (char *) malloc ((size_t)MAXWORD*sizeof(char)))==NULL)
		{
		ErrTrace ("AllocSmallMolecule",OUTOFMEM);
		return (OUTOFMEM);
		}
	ibytes += (MAXWORD*sizeof(char));

	if ((mol[i]->molid = (char *) malloc ((size_t)MAXWORD*sizeof(char)))==NULL)
		{
		ErrTrace ("AllocSmallMolecule",OUTOFMEM);
		return (OUTOFMEM);
		}
	ibytes += (MAXWORD*sizeof(char));

	if ((mol[i]->atomtyp = (char **) calloc ((size_t)lnat,sizeof(char *)))==NULL)
		{
		ErrTrace ("AllocSmallMolecule",OUTOFMEM);
		return (OUTOFMEM);
		}
	ibytes += (lnat*sizeof(char*));

	for (j=0;j<lnat;j++)
		{
		if ((mol[i]->atomtyp[j] = (char *) malloc ((size_t)5*sizeof(char)))==NULL)
			{
			ErrTrace ("AllocSmallMolecule",OUTOFMEM);
			return (OUTOFMEM);
			}
		}
	ibytes += (lnat*sizeof(char)*5);

	if ((mol[i]->bondtyp = (int *) calloc ((size_t)lnbd,sizeof(int)))==NULL)
		{
		ErrTrace ("AllocSmallMolecule",OUTOFMEM);
		return (OUTOFMEM);
		}
	ibytes += (lnbd*sizeof(int));

	if ((mol[i]->bonds = (int **) calloc ((size_t)lnbd,sizeof(int *)))==NULL)
		{
		ErrTrace ("AllocSmallMolecule",OUTOFMEM);
		return (OUTOFMEM);
		}
	ibytes += (lnbd*sizeof(int **));
	
	for (j=0; j<lnbd; j++)
		{
		if ((mol[i]->bonds[j] = (int *) calloc ((size_t)2,sizeof(int)))==NULL)
			{
			ErrTrace ("AllocSmallMolecule",OUTOFMEM);
			return (OUTOFMEM);
			}
		ibytes += (sizeof(int)*2);
		}

	if ((mol[i]->atoms = (double **) calloc ((size_t)lnat,sizeof(double *)))==NULL)
		{
		ErrTrace ("AllocSmallMolecule",OUTOFMEM);
		return (OUTOFMEM);
		}
	ibytes += (lnat*sizeof(double **));
	
	for (j=0; j<lnat; j++)
		{
		if ((mol[i]->atoms[j] = (double *) calloc ((size_t)3,sizeof(double)))==NULL)
			{
			ErrTrace ("AllocSmallMolecule",OUTOFMEM);
			return (OUTOFMEM);
			}
		ibytes += (sizeof(double)*3);
		}
	}

sys->molecules = (void **)mol;
fprintf (stdout,"Bytes allocated for system : %d\n",ibytes);
fprintf (stdout,"Number of small molecules in load block : %d\n",ialloc);
#ifdef DBG
fprintf (stdout,"DBG >> AllSmallMolecule() - done !\n");
#endif
return (TRUE);
}
