/*****************************************************************************

                'J' - Yet Another Molecular Mechanics Program

                           (c) 1995 Jan T Pedersen


This program is not in the public domain and may not be used or distributed
by anyone without the written permission of the author. The functionality
of the whole or parts of the program is not guaranteed.

******************************************************************************
 $Header$
 $Revision$
*****************************************************************************/

#include "Graph.h"

void AllShortestPaths(const Graph *pgraph,Graph *preduced)
{
int nnodes,i,j,k;
int d_ij;

#ifdef DBG
fprintf (stdout,"DBG >> AllShortestPaths()\n");
#endif
nnodes=(*pgraph).nnodes;
for (i=0;i<nnodes;i++)
  	{
    	for (j=0;j<nnodes;j++)
    		{
      		if (i==j)
        		preduced->M[i*nnodes+i]=0;
      		else if (pgraph->M[i*nnodes+j]>0)
        		preduced->M[i*nnodes+j]=1;
      		else
        		preduced->M[i*nnodes+j]=100000;
    		}
  	}

for (k=0;k<nnodes;k++)
  	{
    	for (i=0;i<nnodes;i++)
    		{
      		for (j=i+1;j<nnodes;j++)
      			{
        		d_ij=preduced->M[i*nnodes+k]+preduced->M[k*nnodes+j];
        		if (d_ij<preduced->M[i*nnodes+j])
        			{
          			preduced->M[i*nnodes+j]=d_ij;
          			preduced->M[j*nnodes+i]=d_ij;
        			}
      			}
    		}
  	}
#ifdef DBG
fprintf (stdout,"DBG >> AllShortestPaths() - done !\n");
#endif
}
