/*****************************************************************************

                'J' - Yet Another Molecular Mechanics Program

                           (c) 1995 Jan T Pedersen


This program is not in the public domain and may not be used or distributed
by anyone without the written permission of the author. The functionality
of the whole or parts of the program is not guaranteed.

******************************************************************************
 $Header$
 $Revision$
*****************************************************************************/

#include "Graph.h"

Graph* AllocGraph(int nnodes)
{
Graph *pgraph=NULL;
int i,nn=0;

#ifdef DBG
fprintf (stdout,"DBG >> AllocGraph()\n");
#endif

if ((pgraph=(Graph*)malloc(sizeof(Graph)))==NULL)
	{
	ErrTrace ("AllocGraph", OUTOFMEM);
	return (NULL);
	}
pgraph->nnodes=nnodes;
nn = (nnodes+1)*(nnodes+1);

if ((pgraph->M=(int *)calloc((size_t)(nn),sizeof(int)))==NULL)
	{
	fprintf (stdout,"Error : AllocGraph() - Unable to allocate memory\n");
	ErrTrace ("AllocGraph", OUTOFMEM);
      	free(pgraph);
	return (NULL);
	}
for (i=0;i<nn;i++)
        SetNoPaths(&(pgraph->M[i]));

#ifdef DBG
fprintf (stdout,"DBG >> AllocGraph() nnodes : %d - done\n",nnodes);
fprintf (stdout,"DBG >> AllocGraph() sizeof(pgraph): %d, sizeof(pgraph->M): %d\n",sizeof(pgraph),sizeof(pgraph->M));
#endif
return pgraph;
}

