/*****************************************************************************

                'J' - Yet Another Molecular Mechanics Program

                           (c) 1995 Jan T Pedersen


This program is not in the public domain and may not be used or distributed
by anyone without the written permission of the author. The functionality
of the whole or parts of the program is not guaranteed.

******************************************************************************
 $Header$
 $Revision$
*****************************************************************************/

#include "Graph.h"

int FreeGraph(Graph *pgraph)
{
int i;
#ifdef DBG
fprintf (stdout,"DBG >> FreeGraph() \n");
fprintf (stdout,"DBG >> FreeGraph() [nnodes : %d]\n",pgraph->nnodes);
for (i=0;i<pgraph->nnodes;i++)
	{
	fprintf (stdout, "[%d:%d]",i,pgraph->M[i]);
	fflush (stdout);
	}
fprintf (stdout, "\n");
#endif

if (pgraph!=NULL)
	{
#ifdef DBG
fprintf (stdout,"DBG >> FreeGraph() - step 1\n");
#endif
	if (pgraph->M != NULL)
    		free((void *)pgraph->M);
	else
		fprintf (stdout,"FreeGraph() ERROR ==> Problem deallocating graph !\n");
#ifdef DBG
fprintf (stdout,"DBG >> FreeGraph() - step 2\n");
#endif
	pgraph->M=NULL;
    	free((void *)pgraph);
  	}
else
	fprintf (stdout,"Error : Problem deallocating graph !\n");
#ifdef DBG
fprintf (stdout,"DBG >> FreeGraph() - done\n");
#endif
return (TRUE);
}

