/*****************************************************************************

                'J' - Yet Another Molecular Mechanics Program

                           (c) 1995 Jan T Pedersen


This program is not in the public domain and may not be used or distributed
by anyone without the written permission of the author. The functionality
of the whole or parts of the program is not guaranteed.

******************************************************************************
 $Header$
 $Revision$
*****************************************************************************/

#include "Graph.h"

void RecurReduceGraph(const Graph *pgraph,Graph *preduced,int *visited,
                      int startnode,int prevnode,int length)
{
int i,nnodes,*M_p_n,*M_s_n,*M_i_n,length_bit,*visited_i;

#ifdef DBG
fprintf (stdout,"DBG >> RecurReduceGraph()\n");
#endif

nnodes=(*pgraph).nnodes;

M_p_n=pgraph->M+prevnode*nnodes;
M_s_n=preduced->M+startnode*nnodes;
M_i_n=preduced->M+startnode;
visited_i=visited;

for (i=0;i<nnodes;i++,M_i_n+=nnodes,M_p_n++,M_s_n++,visited_i++)
	{
      	if (!*visited_i && *M_p_n)
      		{
        	if (length>MaxPathLength)
          		length=MaxPathLength;
        	length_bit=1<<length;
        	*M_i_n|=length_bit;
        	*M_s_n|=length_bit;

/* 
 * continue recursion :
 */
        	*visited_i=1;
        	RecurReduceGraph(pgraph,preduced,visited,startnode,i,length+1);
        	*visited_i=0;
      		}
    	}
#ifdef DBG
fprintf (stdout,"DBG >> RecurReduceGraph() - done\n");
#endif
}
