/*****************************************************************************

                'J' - Yet Another Molecular Mechanics Program

                           (c) 1995 Jan T Pedersen


This program is not in the public domain and may not be used or distributed
by anyone without the written permission of the author. The functionality
of the whole or parts of the program is not guaranteed.

******************************************************************************
 $Header$
 $Revision$
*****************************************************************************/

#include "Graph.h"

Graph* ReduceGraph(const Graph *pgraph)
{
Graph *presult=NULL;
int nnodes,error;
#ifdef DBG
fprintf (stdout,"DBG >> ReduceGraph()\n");
#endif

if (pgraph != NULL)
  	{
    	error=0;
    	nnodes=(*pgraph).nnodes;
    	if ((presult=AllocGraph(nnodes))==NULL)
		{
		ErrTrace ("ReduceGraph", OUTOFMEM);
		return (NULL);
		}
      	AllShortestPaths(pgraph,presult);
    	}
else
	{
	ErrTrace ("ReduceGraph", OUTOFMEM);
	return (NULL);
	}
#ifdef DBG
fprintf (stdout,"DBG >> ReduceGraph() - done\n");
#endif
return presult;
}
