/*****************************************************************************

                'J' - Yet Another Molecular Mechanics Program

                           (c) 1995 Jan T Pedersen


This program is not in the public domain and may not be used or distributed
by anyone without the written permission of the author. The functionality
of the whole or parts of the program is not guaranteed.

******************************************************************************
* $Header: /usr/people/jan/progs/J/Source/Types/RCS/Derivatives.h,v 1.1 1996/03/20 17:44:00 jan Exp jan $
* $Revision: 1.1 $
******************************************************************************

 Derivatives:

 Torsional derivatives are stored as a total energy change for the
 independent torsion angle.

******************************************************************************/
typedef struct _Derivatives
	{
	double *dDdT1;		/* first derivatives of distance as a function of angle tau */
	double *dDdT1_s;	/* first derivatives of distance - save copy for FBMc */
	double **dDdT2;		/* second derivatives of distance as a function of angle tau1 and tau2 */

	double *dEljdT1;	/* first derivative of the lennard-jones function */
	double *dEcouldT1;	/* first derivative of the coulombics */
	double *dEtetherdT1;	/* first derivative of the tetherings */
	} Derivatives;
