/*****************************************************************************

                'J' - Yet Another Molecular Mechanics Program

                           (c) 1995 Jan T Pedersen


This program is not in the public domain and may not be used or distributed
by anyone without the written permission of the author. The functionality
of the whole or parts of the program is not guaranteed.

******************************************************************************
* $Header: /usr/people/jan/progs/J/Source/Types/RCS/ForceField.h,v 1.1 1996/03/20 17:44:00 jan Exp jan $
* $Revision: 1.1 $
******************************************************************************

 ForceField.h

 Force Field definitions, the only thing to said here is that
 E_CLASH always has to be element number zero. This is done
 to allow for quick truncation of the energy calculation.

******************************************************************************/
#define MOL_ENERGIES    23

#define E_CLASH		0
#define E_COULOMB       1
#define E_LOCAL         2
#define E_NONLOCAL      3
#define E_HB            4
#define E_SIDECHAIN     5
#define E_PHOBE         6
#define E_CHI           7
#define E_SOLVENT       8
#define E_LJ            9
#define E_BURIAL        10
#define E_CONTACT	11
#define E_TETHER	12
#define E_LCORR         13
#define E_HBCORR        14
#define E_APAIR         15
#define E_JLOCAL        16
#define E_JNONLOCAL     17
#define E_PMF_LOCAL     18
#define E_PMF_NONLOCAL  19
#define E_GUIDE		20
#define E_PMF_SIDE	21
#define E_BORN		22

typedef struct _ForceField
        {
        int     init;                   /* has the forcefield initialised ? */
        int     init_fast;              /* has the forcefield initialised the fast way */
        int     ETerms[MOL_ENERGIES];   /* Flags for energy terms */
	} ForceField;
