/*****************************************************************************

                'J' - Yet Another Molecular Mechanics Program

                           (c) 1995 Jan T Pedersen


This program is not in the public domain and may not be used or distributed
by anyone without the written permission of the author. The functionality
of the whole or parts of the program is not guaranteed.

******************************************************************************
* $Header: /usr/people/jan/progs/J/Source/Types/RCS/Molecule.h,v 1.1 1996/03/20 17:44:00 jan Exp jan $
* $Revision: 1.1 $
******************************************************************************/
#define MOL_PARAMS 	7

typedef struct _Molecule
	{
	int natoms;		/* Number of atoms 	*/
        int *atomno;		/* Atom numbers    	*/
        int *resno;             /* Residue number  	*/
        char **atomtyp;         /* Atom type       	*/
        char **grouptyp;        /* Group type      	*/
        char **potentyp;        /* Potential type  	*/
        char **restyp;          /* Residue type    	*/
        double **v;             /* Coordinates     	*/
	double **params;        /* Parameters      	*/

        void *sim;              /* Pointer to simulation datastructures */

        int nbond;              /* Number of bonds 	*/
	int **bond;             /* Bond list       	*/

        void *tree;		/* Tree (chemical graph)*/
        void **treemap;         /* Linear map of atoms to tree */

	int ntor;               /* Number of torsions 	*/
	int **torsion;          /* Torsion list		*/
        double *dihedral;       /* Dihedrals in molecule*/
	void *refmol;		/* A reference molecule */
	} Molecule;
