/*****************************************************************************

                'J' - Yet Another Molecular Mechanics Program

                           (c) 1995 Jan T Pedersen


This program is not in the public domain and may not be used or distributed
by anyone without the written permission of the author. The functionality
of the whole or parts of the program is not guaranteed.

******************************************************************************
 $Header: /usr/people/jan/progs/J/Source/Types/RCS/PMFElocEnonlocData.h,v 1.1 1996/03/20 17:44:00 jan Exp jan $
 $Revision: 1.1 $
******************************************************************************/

typedef struct _PMFElocEnonlocData
	{
	int    npair;		/* The number of residue pairs in the parameterset */
	int    nres;		/* Number of residues */
	int    nside;		/* Number of eside bins */
	int    nloc, nonloc;	/* The number of local and nonlocal datapoints */
	double eloc_first;	/* First eloc bin */
	double enonloc_first;	/* First enonloc bin */
	double eside_first;	/* First sidechain bin */
	double eloc_last;
	double enonloc_last;
	double eside_last;
	double eloc_bin_size;	/* Bin size for Elocal */
	double enonloc_bin_size;/* Bin size for Enonlocal */
	double eside_bin_size;	/* Bin size for Esize */
	char   **residue;	/* Residue types */
	char   ***respair;	/* Residue type pairs */
	char   ***group_pair;	/* Group pairs */
	double **eloc;		/* The elocs */
	double **enonloc;	/* The Ehbs */
	double **eside;         /* The Esides */
	} PMFElocEnonlocData;
