/*****************************************************************************

                'J' - Yet Another Molecular Mechanics Program

                           (c) 1995 Jan T Pedersen


This program is not in the public domain and may not be used or distributed
by anyone without the written permission of the author. The functionality
of the whole or parts of the program is not guaranteed.

******************************************************************************
* $Header: /usr/people/jan/progs/J/Source/Types/RCS/Parameter.h,v 1.1 1996/03/20 17:44:00 jan Exp jan $
* $Revision: 1.1 $
****************************************************************************** 

 Parameter.h

 Including this file should give access to all the parameter data in
 the program. The pointer J_Parameter is set if a datafile has been
 read in. If a bit of data is not there the respective pointer will
 be set to NULL - This is checked in all the routines.

******************************************************************************/
#include "AnglibData.h"
#include "ElocEnonlocData.h"
#include "JElocEnonlocData.h"
#include "ElocData.h"
#include "ShoshData.h"
#include "ChiData.h"
#include "EScaleData.h"
#include "ShrakeRupleyData.h"
#include "SidelibData.h"
#include "TripleData.h"
#include "AtomPairPotData.h"
#include "PMFElocEnonlocData.h"

typedef struct _Parameter
	{
	void *ElocEnonlocData;    /* New Peter parameter data */
	void *JElocEnonlocData;   /* Jan parameter data */
	void *ElocData;           /* Old Peter local scaling factors */
	void *ShoshData;          /* Wodak phi/psi map */ 
	void *AnglibData;         /* Angle library data */ 
	void *ChiData;            /* Chi potential parameters */ 
	void *EScaleData;         /* Non-local scale factors for old Peter potential */ 
	void *ShrakeRupleyData;   /* Shrake Rupley areas */ 
	void *SidelibData;        /* Library of preferred sidechain angles */ 
        void *TripleData;         /* Multiple move data */
        void *AtomPairPotData;    /* Pair-potential data */
	void *PMFElocEnonlocData; /* PMF electrostatic model */
	} Parameter;
