/*****************************************************************************

                'J' - Yet Another Molecular Mechanics Program

                           (c) 1995 Jan T Pedersen


This program is not in the public domain and may not be used or distributed
by anyone without the written permission of the author. The functionality
of the whole or parts of the program is not guaranteed.

******************************************************************************
* $Header: /usr/people/jan/progs/J/Source/Types/RCS/Statistics.h,v 1.1 1996/03/20 17:44:00 jan Exp jan $
* $Revision: 1.1 $
******************************************************************************/

#define J_FILE_TYPES		8

#define J_FILE_SAMPLE       	0
#define J_FILE_BESTENERGY   	1
#define J_FILE_STARTPOP  	2
#define J_FILE_GENERATIONS  	3
#define J_FILE_SCREEN        	4
#define J_FILE_POPBIAS       	5
#define J_FILE_BESTRMS   	6
#define J_FILE_CONFORMATIONS    7

typedef struct _Statistics
	{
	int nsteps;
	int **moves;
	FILE *iofiles[J_FILE_TYPES];
	char file_names[J_FILE_TYPES][MAXLINE];

        double noedist[3][2];   /* Distance cutoff for interproton distances 	*/
	int **noe;              /* i->i+1, i->i+2, i->i+3 NOEs counted       	*/

	int **pp;		/* phi/psi index to backbone torsions	    	*/
        int **ppcount;		/* Counts of torsions in shosh bins		*/
	double **dihed;		/* The average dihedrals			*/
	} Statistics;	
